﻿'A reference to the Phidget22.NET.dll must be added to new projects in VB.Net 
'From the "Project" menu select "Add Reference" 
'From the "Add Reference" window select the "Browse" tab 
'Browse to the directory you installed the Phidgets library to 
'The default is "C:\Program Files\Phidgets" 
'Select "Phidget22.NET.dll" and click "OK" 
'To view objects that have been added, select the "View" menu 
'Select "Object Browser" 
'Then expand the Phidget22.NET.dll item 

Imports Phidget22
Imports Phidget22.Events
Imports System.Drawing.Drawing2D
Imports GMap.NET
Imports System.Text
Imports System.Collections
Imports System.Runtime.InteropServices
Imports System.Data
Imports System.Drawing.Graphics
Imports System.ComponentModel

Public Class Form1
    Dim WithEvents device As Phidget22.GPS
    Dim open As ExampleUtils.ExampleUtils.CommandLineOpen
    Dim errorBox As ErrorEventBox

    Dim mapGraphic As Graphics


    Public Sub New()
        open = New ExampleUtils.ExampleUtils.CommandLineOpen(Me)
        ' This call is required by the Windows Form Designer.
        Phidget22.Phidget.InvokeEventCallbacks = True
        InitializeComponent()
        ' Add any initialization after the InitializeComponent() call.
    End Sub

    Public Sub New(ByVal commandLine As String())
        open = New ExampleUtils.ExampleUtils.CommandLineOpen(Me)
        open.commandLine = commandLine
        Phidget22.Phidget.InvokeEventCallbacks = True
        InitializeComponent()
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        errorBox = New ErrorEventBox(Me)
        device = New Phidget22.GPS()
        open.openCmdLine(device)

        mapBox.MapProvider = GMap.NET.MapProviders.GoogleMapProvider.Instance
        mapBox.Position = New GMap.NET.PointLatLng(0, 0)
    End Sub

    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles MyBase.FormClosing
        If device.Attached Then
            device.Close()
        End If
    End Sub

    Private Sub device_Attach(ByVal sender As Object, ByVal e As Phidget22.Events.AttachEventArgs) Handles device.Attach
        Dim attachedDevice As Phidget22.GPS = CType(sender, Phidget22.GPS)
        PhidgetInfoBox1.FillPhidgetInfo(CType(sender, Phidget22.GPS))
        Timer1.Start()

        mapGraphic = pictureBox1.CreateGraphics()

        dataPanel.Visible = True
        outputBox.Visible = True
    End Sub

    Private Sub device_Detach(ByVal sender As Object, ByVal e As Phidget22.Events.DetachEventArgs) Handles device.Detach
        PhidgetInfoBox1.Clear()
        dataPanel.Visible = False
        outputBox.Visible = False
    End Sub

    Private Sub device_Error(ByVal sender As Object, ByVal e As Phidget22.Events.ErrorEventArgs) Handles device.Error
        errorBox.addMessage(e.Description)
    End Sub

    Private Sub device_PositionChange(ByVal sender As Object, ByVal e As Phidget22.Events.GPSPositionChangeEventArgs) Handles device.PositionChange
        latTxt.Text = e.Latitude.ToString("f6")
        longTxt.Text = e.Longitude.ToString("f6")
        altTxt.Text = e.Altitude.ToString("f1") + "m"

        Try
            headTxt.Text = device.Heading.ToString()
            velTxt.Text = device.Velocity.ToString("f1") + "km/h"
        Catch ex As Exception

        End Try

        Try
            If (checkBox1.Checked) Then
                mapBox.Position = New GMap.NET.PointLatLng(e.Latitude, e.Longitude)
            End If
        Catch ex As Exception

        End Try

        Dim xcoor1 As Double = 0, ycoor1 As Double = 0, xcoor2 As Double = 0, ycoor2 As Double = 0
        Dim head As Double = 0

        Try
            head = device.Heading
        Catch ex As Exception

        End Try
        xcoor1 = (Math.Sin(((head + 180) * 0.0174532925)) * 10) + 10
        ycoor1 = (Math.Cos(((head + 180) * 0.0174532925)) * 10) + 10
        xcoor2 = 10 - (Math.Sin(((head + 180) * 0.0174532925)) * 10)
        ycoor2 = 10 - (Math.Cos(((head + 180) * 0.0174532925)) * 10)

        mapGraphic.Clear(Color.FromName("Control"))
        mapGraphic.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.AntiAlias
        Dim p As Pen = New Pen(Color.Black, 4)
        p.StartCap = LineCap.Round
        p.EndCap = LineCap.ArrowAnchor
        mapGraphic.DrawLine(p, CType(xcoor2, Single), CType(ycoor2, Single), CType(xcoor1, Single), CType(ycoor1, Single))
        p.Dispose()

    End Sub

    Private Sub device_PositionFixStatusChange(ByVal sender As Object, ByVal e As Phidget22.Events.GPSPositionFixStateChangeEventArgs) Handles device.PositionFixStateChange
        Dim attachedDevice As Phidget22.GPS = CType(sender, Phidget22.GPS)
        checkBox1.Checked = attachedDevice.PositionFixState
        If (attachedDevice.PositionFixState = False) Then
            latTxt.Text = "Unknown"
            longTxt.Text = "Unknown"
            altTxt.Text = "Unknown"
            headTxt.Text = "Unknown"
            velTxt.Text = "Unknown"
        End If

        mapBox.Visible = attachedDevice.PositionFixState
        mapViewButton.Visible = attachedDevice.PositionFixState
        satelliteViewButton.Visible = attachedDevice.PositionFixState
        hybridViewButton.Visible = attachedDevice.PositionFixState
    End Sub

    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        If (device.Attached) Then
            Try
                'GPS time is in UTC convert to local time
                Dim localTime As DateTime = device.DateAndTime.ToLocalTime()

                timeTxt.Text = "Time: " + localTime.Hour.ToString("D2") + ":" + localTime.Minute.ToString("D2") + ":" + localTime.Second.ToString("D2") + "." + localTime.Millisecond.ToString("D3")
                dateTxt.Text = "Date: " + localTime.Day + "/" + localTime.Month + "/" + localTime.Year
            Catch ex As Exception

            End Try
        End If
    End Sub

    Private Sub mapViewButton_Click(sender As Object, e As EventArgs) Handles mapViewButton.Click
        mapBox.MapProvider = GMap.NET.MapProviders.GoogleMapProvider.Instance
    End Sub

    Private Sub hybridViewButton_Click(sender As Object, e As EventArgs) Handles hybridViewButton.Click
        mapBox.MapProvider = GMap.NET.MapProviders.GoogleHybridMapProvider.Instance
    End Sub

    Private Sub satelliteViewButton_Click(sender As Object, e As EventArgs) Handles satelliteViewButton.Click
        mapBox.MapProvider = GMap.NET.MapProviders.GoogleSatelliteMapProvider.Instance
    End Sub
End Class
